<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL ^ E_NOTICE);

$wifiClientTry = array_key_exists("ssid", $_POST) && strlen($_POST["ssid"])>0;
$wifiAPTry = array_key_exists("ap", $_GET);

$txtPath = "settings/wifi.txt";
$shPath = "settings/wifi.sh";

$oldssid = "";

if(file_exists($txtPath)){
	$fn = fopen($txtPath,"r");
	$oldssid = rtrim(fgets($fn));
	$oldpass = rtrim(fgets($fn));
	fclose($fn);
}

?>

<!DOCTYPE html> 
<html> 
<head>
	<link rel="stylesheet" type="text/css" href="css/style.css">
	<title>SensorBox Wifi Connection</title>
</head> 
<body>
	<center>
	<?php if($wifiAPTry){
		if(file_exists($txtPath)){unlink($txtPath);}//TODO nmcli delete old connection
		if(file_exists($shPath)){unlink($shPath);}?>
	Wifi AP Mode enabled successfully. Changes will apply on next reboot.<br><br>
	<a href="index.html" class="Button">Back</a>
	<?php }else if($wifiClientTry && (strpos($_POST["ssid"], '\'') !== false || strpos($_POST["pass"], '\'') !== false)){?>
	Error: ' character is not allowed in SSID or password.<br><br>
	<a href="index.html" class="Button">Back</a>
	<?php }else if($wifiClientTry){
		$txtFile = fopen($txtPath, "w");
		$content = $_POST["ssid"]."\n".$_POST["pass"];
		fwrite($txtFile, $content);
		fclose($txtFile);
		$shFile = fopen($shPath, "w");
		$content =
'#!/bin/bash

set -v
nmcli connection down SensorBox88
systemctl start wpa_supplicant.service';
		if(strlen($oldssid)>0){
			$content = $content.'
nmcli connection delete \''.$oldssid.'\'';
		}
		$content = $content.'
nmcli connection delete \''.$_POST["ssid"].'\'
nmcli device wifi rescan';
		if(strlen($_POST["pass"])==0){
			$content = $content.'
nmcli device wifi connect \''.$_POST["ssid"].'\'';
		}else{
			$content = $content.'
nmcli device wifi connect \''.$_POST["ssid"].'\' password \''.$_POST["pass"].'\'';
		}
$content = $content.'
nmcli connection show --active | grep wlan0 &> /dev/null
if [ "$?" == "1" ]; then
	nmcli connection up SensorBox88
fi
sync';
		fwrite($shFile, $content);
		fclose($shFile);
		system("sync");
		?>
	Wifi Client Mode has been set up. Changes will apply on next reboot.<br><br>
	<a href="index.html" class="Button">Back</a>
	<?php }else{ ?>
	<img src="icon.png" width="9%">
	<h3>Set Up Wifi Mode:</h3>
	<h4>Create own Wifi Access Point:</h4>
	<a href="ap.php?ap=ap" class="Button">Use own Wifi Access Point</a>
	<h4>Connect to other Wifi:</h4>
	Please specify the SSID and key (password can be empty in case of open wifi) here to connect to another wifi as client.<br>
	A connection is tried each boot of the SensorBox.<br>
	If the connection fails it automatically falls back to AP (Access Point) mode.<br>
	Note: Horizon 2.9 or later is required to find the SensorBox in wifi client mode.<br><br>
	<form action="ap.php" method="post">
		SSID:<br>
		<?php
		if(strlen($oldssid)>0){
			echo "<input type=\"text\" maxlength=\"150\" name=\"ssid\" value=\"$oldssid\" placeholder=\"SSID\"><br>";
			echo "Password:<br>";
			echo "<input type=\"password\" maxlength=\"150\" name=\"pass\" value=\"$oldpass\" placeholder=\"Password\" id=\"pass\"><br>";
		}else{
		?>
		<input type="text" maxlength="150" name="ssid" value="" placeholder="SSID"><br>
		Password:<br>
		<input type="password" maxlength="150" name="pass" placeholder="Password" id="pass"><br>
		<?php } ?>
		<input type="checkbox" onclick="showPwd()">Show Password<br><br>
		<input type="submit" name="action" value="Use other Wifi" class="Button"><br><br>
	</form>
	<a href="index.html" class="Button">Cancel</a>
	<?php } ?>
	</center>
	<script>
	function showPwd() {
		var x = document.getElementById("pass");
		if(x.type === "password") {
			x.type = "text";
		}else{
			x.type = "password";
		}
	}
	</script>
</body>
</html>
